(defun MM-switch-tuple-menu ()
  ""
  (interactive)
  (message "OK")
  (let* (
	 (seq (this-command-keys))
	 (len (1- (length seq)))
	 (symbol (aref seq len))
	 )
    (message "OK")
    (switch-to-buffer  (symbol-name symbol))
    )
  )




;; append atoms
(defun MM-insert-in-tuples-map (string)
  ""
  (define-key MM-tuples-map (make-vector 1 (intern string))
    (cons string  'MM-switch-tuple-menu))
  )

(defun MM-insert-in-searches-map (string)
  ""
  (define-key MM-searches-map (make-vector 1 (intern string))
    (cons string  'MM-switch-tuple-menu)) ; THE SAME AS TUPLES
  )
;; widget-menu-max-size

;; convert from lists into menus
(defun MM-update-searches-map ()
  (setq MM-searches-map (make-sparse-keymap "MM searches"))
  (mapcar 'MM-insert-in-searches-map MM-searches-ring)
  (fset 'MM-searches-map  MM-searches-map)
  )

(defun MM-update-tuples-map ()
  (setq MM-tuples-map (make-sparse-keymap "MM tuples"))
  (mapcar 'MM-insert-in-tuples-map MM-tuples-list)
  (fset 'MM-tuples-map  MM-tuples-map)
  )
;; (MM-update-tuples-map)







;;; MAPS
(defvar MM-tuples-map
  (make-sparse-keymap "MM tuples"))

;;(setq MM-tuples-map (make-sparse-keymap "MM tuples"))
(fset 'MM-tuples-map  MM-tuples-map)


(defvar MM-searches-map
  (make-sparse-keymap "MM searches"))



(defvar MM-qbe-map
  (make-sparse-keymap "MM QBE"))
(define-key MM-qbe-map [person]
  '("Person" . person-qbe))
(define-key MM-qbe-map [libri]
  '("libri" . libri-qbe))

(fset 'MM-qbe-map  MM-qbe-map)





(defvar MM-menu-map
  (make-sparse-keymap "MM commands"))
(fset 'MM-menu-map  MM-menu-map)
     
(define-key MM-menu-map [start]
  '("Start the TCP-channel" . completer-start))
(define-key MM-menu-map [qbe]
  '("QBE" . MM-qbe-map))
(define-key MM-menu-map [person]
  '("Get a person" . MM-get-person))
(define-key MM-menu-map [switch]
  '("Switch tuple" . MM-switch-tuple))
(define-key MM-menu-map [tuples]
  '("Switch T" . MM-tuples-map))
(define-key MM-menu-map [searches]
  '("Switch S" . MM-searches-map))
(define-key MM-menu-map [list]
  '("List searches" . MM-list-searches))
(define-key MM-menu-map [save]
  '("Save" . save-buffer))
(define-key MM-menu-map [kill]
  '("Kill" . kill-buffer))
     


(define-key global-map [C-S-down-mouse-1] 'MM-menu-map)


;(get 'save-buffer 'menu-enable)

(string-to-vector "list")


(provide 'MM-mouse)

;; (x-popup-menu   (list '(0 0) (selected-window))  '("menu1" ("sub" ("A". 1)  ("B". 2)))   )

